// This is an extension of the file NS_2014_NO_FF.mod that;
// eliminates from the forward looking equations backward looking variables;
// it does this by generating dummy variables ;
// version: 18-Jul-2014 11:08:42;
// NS 2014;;
%-------------------------------------------;
% written 11 June 2014;
%------------------------------------------;
% periods=0;;
%--------------------------------------------;welf,;
% Give variables names and innovations (of the shocks) names;
% Notice that the AR(p) shocks are added to the structural equations;tax,;
%----------------------------------------------;;
var  well,AP,AP_D,C,DS,Dp,Dp_D,GDP,L_C,L_D,MC,MC_D,N_C_S,N_D_S,PI_D,R,T_D,UC,UC_D,UCbis,Util,W_C,W_C_S,W_D,W_D_S,XI,Y,Z,ZP1,ZP1_D,ZP2,ZP2_D,Z_D,pii,stuS, 
ramsey1,ramsey2,ramsey3,ramsey4,ramsey5,ramsey6,ramsey7,ramsey8,ramsey9,ramsey10,ramsey11,ramsey12,ramsey13,ramsey14,ramsey15,ramsey16,ramsey17,ramsey18,ramsey19,ramsey20,ramsey21,ramsey22,ramsey23,ramsey24,ramsey25,ramsey26,ramsey27,ramsey28,ramsey29,ramsey30,ramsey31,ramsey32,
shock_H;
// ;
varexo E_H;  
%-----------------------------------------------;
% GIVE PARAMETER'S NAMES
%----------------------------------------------;
parameters constL, constW, nbeta, mu, muw_C, muw_D,	subv,	betta,	sig_c,	phi_y,	gamma_p,	xi_p,	sig_l_C,	r_PI,	r_dy,	rho,	Lst,	tau_D,	hetha_D,	omega_D,	chi_NR,	omega_NR,	phi_y_D,	alph_D, xi_p_D,	gamma_p_D,	mu_D,	subv_D,	rho_LTV,	rho_H,	alph_LAN, diff_betta,	r_PID,	betta_NR,	sig_l_D, sig_l_C_NR,	sig_l_D_NR,	
LANDst, Z_ss, Z_D_ss, Gst, TRS, R_ss, GDP_ss, pii_ss, PI_D_ss, LCBAR,  LDBAR,  LC_NRBAR,  LD_NRBAR, std_LTV, std_H, poly;			
										
									
%---------------------------------------------------;
% start here 
%---------------------------------------------------;
parameters nash_param aleph;  // ;
model;
// ;
// Welfare;
well = Util + betta*well(+1);
Util=stuS;
// Policy Rule;
// poly-((1+R)/(1+R_ss))+((pii/pii_ss)^((r_PI)*(1-rho)))*((GDP/GDP(-1))^(r_dy*(1-rho)))*(((1+PI_D)/(1+PI_D_ss))^(r_PID*(1-rho)))*(((1+R(-1))/(1+R_ss))^rho);
// ;
T_D*UC-(UC_D+betta*(1-tau_D)*UC(+1)*T_D(+1))=0;
UC-(UC(+1)*betta*(1+R)/(pii(+1)))=0;
ZP1_D-(UC*MC_D*Z_D*T_D+betta*xi_p_D*AP_D(+1)^(mu_D/(mu_D-1))*ZP1_D(+1))=0;
ZP2_D-(UC*Z_D*T_D+betta*xi_p_D*AP_D(+1)^(1/(mu_D-1))*ZP2_D(+1))=0;
ZP1-(UC*MC*Z+betta*xi_p*AP(+1)^(mu/(mu-1))*ZP1(+1))=0;
ZP2-(UC*Z+betta*xi_p*AP(+1)^(1/(mu-1))*ZP2(+1))=0;
// ;
stuS-(log(XI)-LCBAR*(N_C_S)^(1+sig_l_C)/(1+sig_l_C)-LDBAR*(N_D_S)^(1+sig_l_D)/(1+sig_l_D))=0                          ;
Z-((L_C)-(phi_y-1)*Z_ss)=0                                                                                            ;
Z_D-((L_D)-(phi_y_D-1)*Z_D_ss)=0                                                                                      ;
AP-((pii)*(pii(-1))^(-gamma_p)*(pii_ss)^(gamma_p-1))=0                                                                ;
AP_D-((1+PI_D)*(1+PI_D(-1))^(-gamma_p_D)*(1+PI_D_ss)^(gamma_p_D-1))=0                                                 ;
MC-(W_C)=0                                                                                                            ;
MC_D-(W_D)=0                                                                                                          ;
XI-((C^(1-exp(shock_H)*omega_D))*(DS^(exp(shock_H)*omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D)))))=0     ;
UCbis-(1/XI)=0                                                                                                        ;
UC-(UCbis*(1-exp(shock_H)*omega_D)*(C/DS)^(-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D)))))=0;
UC_D-(UCbis*exp(shock_H)*omega_D*(C/DS)^(1-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D)))))=0 ;
Y-(C+Gst*Z_ss)=0                                                                                                      ;
Z-(Dp*Y)=0                                                                                                            ;
Z_D-((DS-(1-tau_D)*DS(-1)))=0                                                                                         ;
W_C-(W_C_S)=0                                                                                                         ;
W_D-(constW*W_D_S)=0                                                                                                  ;
L_C-((N_C_S))=0                                                                                                       ;
L_D-(constL*(N_D_S))=0                                                                                                ;
W_C_S-((LCBAR*(N_C_S)^(sig_l_C))*(1/UC))=0                                                                            ;
W_D_S-((LDBAR*(N_D_S)^(sig_l_D))*(1/UC))=0                                                                            ;
Dp_D-((1-xi_p_D)*(mu_D*(1-subv_D)*ZP1_D/ZP2_D)^(-mu_D/(mu_D-1))+xi_p_D*Dp_D(-1)*AP_D^(mu_D/(mu_D-1)))=0               ;
(mu_D*(1-subv_D)*ZP1_D/ZP2_D)^(1/(1-mu_D))*(1-xi_p_D)-(1-xi_p_D*AP_D^(1/(mu_D-1)))=0                                  ;
Dp-((1-xi_p)*(mu*(1-subv)*ZP1/ZP2)^(-mu/(mu-1))+xi_p*Dp(-1)*AP^(mu/(mu-1)))=0                                         ;
(mu*(1-subv)*ZP1/ZP2)^(1/(1-mu))*(1-xi_p)-(1-xi_p*AP^(1/(mu-1)))=0                                                    ;
T_D-(T_D(-1)*(1+PI_D)/(pii))=0                                                                                        ;
GDP-(Z+Z_D*T_D)=0                                                                                                     ;
// FOC of Lagrange problem ;
0+ramsey10*(1)+ramsey29*(-(AP^(mu/(mu - 1) - 1)*Dp(-1)*mu*xi_p)/(mu - 1))+ramsey30*((AP^(1/(mu - 1) - 1)*xi_p)/(mu - 1))+nbeta*(0)+1/nbeta*ramsey5(-1)*(-(AP^(mu/(mu - 1) - 1)*ZP1*betta*mu*xi_p)/(mu - 1))+1/nbeta*ramsey6(-1)*(-(AP^(1/(mu - 1) - 1)*ZP2*betta*xi_p)/(mu - 1))=0;
0+ramsey11*(1)+ramsey27*(-(AP_D^(mu_D/(mu_D - 1) - 1)*Dp_D(-1)*mu_D*xi_p_D)/(mu_D - 1))+ramsey28*((AP_D^(1/(mu_D - 1) - 1)*xi_p_D)/(mu_D - 1))+nbeta*(0)+1/nbeta*ramsey3(-1)*(-(AP_D^(mu_D/(mu_D - 1) - 1)*ZP1_D*betta*mu_D*xi_p_D)/(mu_D - 1))+1/nbeta*ramsey4(-1)*(-(AP_D^(1/(mu_D - 1) - 1)*ZP2_D*betta*xi_p_D)/(mu_D - 1))=0;
0+ramsey14*((DS^(omega_D*exp(shock_H))*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(C^(omega_D*exp(shock_H))*omega_D^omega_D))+ramsey16*(-(UCbis*omega_D*exp(shock_H)*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(DS*omega_D^omega_D*(C/DS)^(omega_D*exp(shock_H) + 1)))+ramsey17*((UCbis*omega_D*exp(shock_H)*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(DS*omega_D^omega_D*(C/DS)^(omega_D*exp(shock_H))))+ramsey18*(-1)+nbeta*(0)=0;
0+ramsey19*(-Y)+ramsey29*(1)+nbeta*(0)+nbeta*ramsey29(+1)*(-AP(+1)^(mu/(mu - 1))*xi_p)=0;
0+ramsey27*(1)+nbeta*(0)+nbeta*ramsey27(+1)*(-AP_D(+1)^(mu_D/(mu_D - 1))*xi_p_D)=0;
0+ramsey14*(-(C^(1 - omega_D*exp(shock_H))*DS^(omega_D*exp(shock_H) - 1)*omega_D*exp(shock_H)*(1 - omega_D)^(omega_D - 1))/omega_D^omega_D)+ramsey16*((C*UCbis*omega_D*exp(shock_H)*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(DS^2*omega_D^omega_D*(C/DS)^(omega_D*exp(shock_H) + 1)))+ramsey17*(-(C*UCbis*omega_D*exp(shock_H)*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(DS^2*omega_D^omega_D*(C/DS)^(omega_D*exp(shock_H))))+ramsey20*(-1)+nbeta*(0)+nbeta*ramsey20(+1)*(1 - tau_D)=0;
0+ramsey32*(1)+nbeta*(0)=0;
0+ramsey8*(-1)+ramsey23*(1)+nbeta*(0)=0;
0+ramsey9*(-1)+ramsey24*(1)+nbeta*(0)=0;
0+ramsey5*(-UC*Z)+ramsey12*(1)+nbeta*(0)=0;
0+ramsey3*(-T_D*UC*Z_D)+ramsey13*(1)+nbeta*(0)=0;
0+ramsey7*(LCBAR*N_C_S^sig_l_C)+ramsey23*(-1)+ramsey25*(-(LCBAR*N_C_S^(sig_l_C - 1)*sig_l_C)/UC)+nbeta*(0)=0;
0+ramsey7*(LDBAR*N_D_S^sig_l_D)+ramsey24*(-constL)+ramsey26*(-(LDBAR*N_D_S^(sig_l_D - 1)*sig_l_D)/UC)+nbeta*(0)=0;
0+ramsey11*(-(PI_D_ss + 1)^(gamma_p_D - 1)/(PI_D(-1) + 1)^gamma_p_D)+ramsey31*(-T_D(-1)/pii)+nbeta*(0)+nbeta*ramsey11(+1)*((gamma_p_D*(PI_D_ss + 1)^(gamma_p_D - 1)*(PI_D(+1) + 1))/(PI_D + 1)^(gamma_p_D + 1))=0;
0+ramsey10*(-pii_ss^(gamma_p - 1)/pii(-1)^gamma_p)+ramsey31*((T_D(-1)*(PI_D + 1))/pii^2)+nbeta*(0)+1/nbeta*ramsey2(-1)*((UC*betta*(R(-1) + 1))/pii^2)+nbeta*ramsey10(+1)*((gamma_p*pii_ss^(gamma_p - 1)*pii(+1))/pii^(gamma_p + 1))=0;
0+ramsey2*(-(UC(+1)*betta)/pii(+1))+nbeta*(0)=0;
1+ramsey7*(1)+nbeta*(0)=0;
0+ramsey1*(UC)+ramsey3*(-MC_D*UC*Z_D)+ramsey4*(-UC*Z_D)+ramsey31*(1)+ramsey32*(-Z_D)+nbeta*(0)+1/nbeta*ramsey1(-1)*(UC*betta*(tau_D - 1))+nbeta*ramsey31(+1)*(-(PI_D(+1) + 1)/pii(+1))=0;
0+ramsey1*(T_D)+ramsey2*(1)+ramsey3*(-MC_D*T_D*Z_D)+ramsey4*(-T_D*Z_D)+ramsey5*(-MC*Z)+ramsey6*(-Z)+ramsey16*(1)+ramsey25*((LCBAR*N_C_S^sig_l_C)/UC^2)+ramsey26*((LDBAR*N_D_S^sig_l_D)/UC^2)+nbeta*(0)+1/nbeta*ramsey1(-1)*(T_D*betta*(tau_D - 1))+1/nbeta*ramsey2(-1)*(-(betta*(R(-1) + 1))/pii)=0;
0+ramsey1*(-1)+ramsey17*(1)+nbeta*(0)=0;
0+ramsey15*(1)+ramsey16*(((omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(omega_D^omega_D*(C/DS)^(omega_D*exp(shock_H))))+ramsey17*(-(omega_D*exp(shock_H)*(C/DS)^(1 - omega_D*exp(shock_H))*(1 - omega_D)^(omega_D - 1))/omega_D^omega_D)+nbeta*(0)=0;
0+ramsey12*(-1)+ramsey21*(1)+nbeta*(0)=0;
0+ramsey21*(-1)+ramsey25*(1)+nbeta*(0)=0;
0+ramsey13*(-1)+ramsey22*(1)+nbeta*(0)=0;
0+ramsey22*(-constW)+ramsey26*(1)+nbeta*(0)=0;
0+ramsey7*(-1/XI)+ramsey14*(1)+ramsey15*(1/XI^2)+nbeta*(0)=0;
0+ramsey18*(1)+ramsey19*(-Dp)+nbeta*(0)=0;
0+ramsey5*(-MC*UC)+ramsey6*(-UC)+ramsey8*(1)+ramsey19*(1)+ramsey32*(-1)+nbeta*(0)=0;
0+ramsey3*(-MC_D*T_D*UC)+ramsey4*(-T_D*UC)+ramsey9*(1)+ramsey20*(1)+ramsey32*(-T_D)+nbeta*(0)=0;
0+ramsey5*(1)+ramsey29*((mu^2*(subv - 1)*(xi_p - 1))/(ZP2*(mu - 1)*(-(ZP1*mu*(subv - 1))/ZP2)^(mu/(mu - 1) + 1)))+ramsey30*(-(mu*(subv - 1)*(xi_p - 1))/(ZP2*(mu - 1)*(-(ZP1*mu*(subv - 1))/ZP2)^(1/(mu - 1) + 1)))+nbeta*(0)+1/nbeta*ramsey5(-1)*(-AP^(mu/(mu - 1))*betta*xi_p)=0;
0+ramsey3*(1)+ramsey27*((mu_D^2*(subv_D - 1)*(xi_p_D - 1))/(ZP2_D*(mu_D - 1)*(-(ZP1_D*mu_D*(subv_D - 1))/ZP2_D)^(mu_D/(mu_D - 1) + 1)))+ramsey28*(-(mu_D*(subv_D - 1)*(xi_p_D - 1))/(ZP2_D*(mu_D - 1)*(-(ZP1_D*mu_D*(subv_D - 1))/ZP2_D)^(1/(mu_D - 1) + 1)))+nbeta*(0)+1/nbeta*ramsey3(-1)*(-AP_D^(mu_D/(mu_D - 1))*betta*xi_p_D)=0;
0+ramsey6*(1)+ramsey29*(-(ZP1*mu^2*(subv - 1)*(xi_p - 1))/(ZP2^2*(mu - 1)*(-(ZP1*mu*(subv - 1))/ZP2)^(mu/(mu - 1) + 1)))+ramsey30*((ZP1*mu*(subv - 1)*(xi_p - 1))/(ZP2^2*(mu - 1)*(-(ZP1*mu*(subv - 1))/ZP2)^(1/(mu - 1) + 1)))+nbeta*(0)+1/nbeta*ramsey6(-1)*(-AP^(1/(mu - 1))*betta*xi_p)=0;
0+ramsey4*(1)+ramsey27*(-(ZP1_D*mu_D^2*(subv_D - 1)*(xi_p_D - 1))/(ZP2_D^2*(mu_D - 1)*(-(ZP1_D*mu_D*(subv_D - 1))/ZP2_D)^(mu_D/(mu_D - 1) + 1)))+ramsey28*((ZP1_D*mu_D*(subv_D - 1)*(xi_p_D - 1))/(ZP2_D^2*(mu_D - 1)*(-(ZP1_D*mu_D*(subv_D - 1))/ZP2_D)^(1/(mu_D - 1) + 1)))+nbeta*(0)+1/nbeta*ramsey4(-1)*(-AP_D^(1/(mu_D - 1))*betta*xi_p_D)=0;
// Exogenous Shocks ;
// Exogenous shocks;											
shock_H=rho_H*shock_H(-1)+E_H;
// ;
end;														
steady;
resid;
check;
shocks;
var	E_H     = std_H^2;
end;
 options_.nograph = 1;
 stoch_simul(order=1,irf=40);
% figure
% subplot(6,2,1)
% plot(oo_.irfs.R_E_H,'r','LineWidth',2)
% legend('Policy rate')
% subplot(6,2,2)
% plot(oo_.irfs.Y_E_H,'b','LineWidth',2)
% legend('GDP')
% subplot(6,2,3)
% plot(oo_.irfs.pii_E_H,'k','LineWidth',2)
% legend('inflation')
% %subplot(6,2,4)
% %plot(oo_.irfs.T_D_E_H,'b-o','LineWidth',2)
% %legend('house price')
% subplot(6,2,4)
% plot(oo_.irfs.PI_D_E_H,'b-o','LineWidth',2)
% legend('house price inflation')
% subplot(6,2,5)
% plot(oo_.irfs.C_E_H,'r-x','LineWidth',2)
% legend('Consumption')
% subplot(6,2,6)
% %plot(oo_.irfs.DS_E_H,'r-x','LineWidth',2)
% %legend('Housing stock')
% plot(oo_.irfs.XI_E_H,'r-x','LineWidth',2)
% legend('Overall consumption basket')
% subplot(6,2,7)
% plot(oo_.irfs.Z_E_H,'r-x','LineWidth',2)
% legend('Nondurable production')
% subplot(6,2,8)
% plot(oo_.irfs.Z_D_E_H,'r-x','LineWidth',2)
% legend('Durable production')
% subplot(6,2,9)
% plot(oo_.irfs.L_C_E_H,'r-x','LineWidth',2)
% legend('labor c')
% subplot(6,2,10)
% plot(oo_.irfs.L_D_E_H,'r-x','LineWidth',2)
% legend('labor d')
% subplot(6,2,11)
% plot(oo_.irfs.W_C_E_H,'r-x','LineWidth',2)
% legend('wage c')
% subplot(6,2,12)
% plot(oo_.irfs.W_D_E_H,'r-x','LineWidth',2)
% legend('wage d')

%==========================================================================
stoch_simul(order=2,irf=0);


w1 = oo_.dr.order_var; 
windx1 = strmatch('well',M_.endo_names(w1,:),'exact');
a1=0.5*oo_.dr.ghs2(windx1);
oldindx1 = strmatch('well',M_.endo_names,'exact'); 
a11 = oo_.dr.ys(oldindx1);
Ut         =  a11 + a1 ;

w2 = oo_.dr.order_var; 
windx2 = strmatch('Util',M_.endo_names(w2,:),'exact');
a2=0.5*oo_.dr.ghs2(windx2);
oldindx2 = strmatch('Util',M_.endo_names,'exact'); 
a22 = oo_.dr.ys(oldindx2);
Uti         =  a22 + a2 ;



%==========================================================================
%betta               = 0.99;
%==========================================================================
% Steady-state (total) consumption:
%XI_ss        	=	 1.06959  ;
%wel_sav = (1/(1-betta))*Uts*XI_ss;
%==========================================================================
% Welfare under Ramsey:
%Utsram  =     -0.361472156471460;
%WELFRAM_S = (1/(1-betta))*Utsram*XI_ss;
%==========================================================================
% Computing welfare gain/loss:
%delta_welf_sav  = 1 - exp((1-betta)   *(WELFRAM_S-wel_sav));
%fprintf	('	WELFARE = ')	;	fprintf	('%f',	Ut	);	disp(';')
%==========================================================================
