

// NS 2014;

%-------------------------------------------
% written 11 June 2014
%------------------------------------------

% periods=0;
%--------------------------------------------;welf,
% Give variables names and innovations (of the shocks) names
% Notice that the AR(p) shocks are added to the structural equations;tax,
%----------------------------------------------;

var well,well_s,well_b, Util,stuff,stuS, stuNR,DS,AP, MC, UCbis, Y,	Z,	AP_D,MC_D,	XINR,	XI,	UCbisNR, Z_D, TOTC, 
UC,	C, UC_D, UCNR, CNR,	UC_DNR,	DNR, PSI, Debt,	L_C, L_D,  Dp, pii, ZP1, ZP2, Dp_D, PI_D, ZP1_D,	ZP2_D, W_C,	W_D, W_C_S,	N_C_S,	W_C_NR,	N_C_NR,	W_D_S, N_D_S,  W_D_NR,	N_D_NR, T_D, GDP,	R, shock_LTV, shock_H;				
//P_L,cgap, pledge, 
varexo E_LTV,E_H ;  

%-----------------------------------------------;
% GIVE PARAMETER'S NAMES
%----------------------------------------------;
parameters nbeta, miu, miuw_C, miuw_D,	subv,	betta,	sig_c,	phi_y,	gamma_p,	xi_p,	sig_l_C,	r_PI,	r_dy,	rho,	Lst,	tau_D,	hetha_D,	omega_D,	chi_NR,	omega_NR,	phi_y_D,	alph_D, xi_p_D,	gamma_p_D,	miu_D,	subv_D,	rho_LTV,	rho_H,	alph_LAN, diff_betta,	r_PID,	betta_NR,	sig_l_D, sig_l_C_NR,	sig_l_D_NR,	
std_LTV, std_H, poly;			
%LANDst, Z_ss, Z_D_ss, Gst, TRS, R_ss, GDP_ss, pii_ss, PI_D_ss, LCBAR,  LDBAR,  LC_NRBAR,  LD_NRBAR, 	constL, constW, 									



%--------------------------------------------------------------------------
pii_ss              = 1;
chi_NR              = 0.2;
hetha_D             = 1.0000001;
omega_D             = 0.1;
miu                 = 1.3;
miu_D               = miu;
subv                = 0;                  
subv_D              = 0;
phi_y_D             = miu_D*(1-subv_D);
phi_y               = miu*(1-subv);
diff_betta          = 3.15;
alph_D              = 0.3;
alpha               = 0.3;
alph_LAN            = 0.15;
betta               = 0.99;
tau_D               = 0.01;
Gst                 = 0.18;
Lst                 = 1;
omega_NR            = 0.2;
sig_l_C             = 2;
sig_l_D         	= 2;
sig_c               = 0.9999;
betta_NR            = 0.960061;
sig_l_C_NR          = 2.000000;
sig_l_D_NR          = 2.000000;

nbeta               = betta;
pii_ss              = (1.00)^(1/4); 
R_ss                = 1/betta*pii_ss - 1; 
PIBAR               = pii_ss -1;

xi_p                = 0.75;
gamma_p             = 0.0;

xi_p_D              = 0;
gamma_p_D           = 0;

alph_LAN            = 0;
miuw_C              = 1 ;
miuw_D              = 1 ;

%--------------------------------------------------------------------------
poly = 0;
%--------------------------------------------------------------------------

rho_H		=	0.95 ;
rho_LTV     =   0.95 ;
std_H       =   3 ;
std_LTV     =   1.25 ;

%--------------------------------------------------------------------------

chi_NR = 0.14;
omega_NR = 0.475;

%--------------------------------------------------------------------------

%==================================================================================================================================
% START LOOP 
%==================================================================================================================================
 
rho_values   = [0.0: 0.1: 0.9];
r_dy_values  = 0;%[0.0: 1: 2];
r_PI_values  = [1.1: 0.1: 5];  %[1.1: 0.1: 5];
r_PID_values = [-1.0: 0.1: 3];  %[-1.0:0.1:3];

srho  = size(rho_values,2); 
srdy  = size(r_dy_values,2); 
srpi  = size(r_PI_values,2);
srpid = size(r_PID_values,2);

tots  = srho*srdy*srpi*srpid; 

    
 BB = 0;
 hw = waitbar(0,'COMPUTING OPTIMAL MONETARY POLICY RULE...');
 for i = 1:length(rho_values); 
      rho = rho_values(i);
          for j = 1:length(r_dy_values); 
            r_dy = r_dy_values(j); 
                 for m = 1:length(r_PI_values);
                   r_PI = r_PI_values(m);
                        for n = 1:length(r_PID_values);
                          r_PID = r_PID_values(n);    



								
%---------------------------------------------------;
% start here 
%---------------------------------------------------;
model;

# pii_ss     = (1.00)^(1/4); 
# R_ss       = 1/betta*pii_ss - 1; 
# Gst        = 0.18;
# P_L_ss     = 1;
# MC_ss      = 1/(miu*(1-subv));
# MC_D_ss    = 1/(miu_D*(1-subv_D));
# PSI_ss     = 1-betta_NR*(1+R_ss)/(pii_ss);
# W_C_ss     = MC_ss;
# W_D_ss     = MC_D_ss; 
# T_D_ss     = miu_D*(1-subv_D)*W_D_ss^(1-alph_LAN)/((1-alph_LAN)^(1-alph_LAN))*(P_L_ss/alph_LAN)^alph_LAN;
# DC_ss      = (omega_D/(1-omega_D))*(1/(T_D_ss*(1-betta*(1-tau_D))));
# DCNR_ss    = (omega_D/(1-omega_D))*1/(T_D_ss*(1-betta_NR*(1-tau_D)-(1-chi_NR)*PSI_ss*pii_ss/(1+R_ss)));
# LAND_LD_ss = (W_D_ss/P_L_ss)*(alph_LAN/(1-alph_LAN)); 
# ZL_ss      = 1/ phi_y;
# ZLD_ss     = (LAND_LD_ss^alph_LAN)/ phi_y_D;
# DebtDNR_ss = (1-chi_NR)*T_D_ss*(pii_ss)/(1+R_ss);
# NUM_ss     = (1/DCNR_ss)*(1-((omega_NR^2)/(1-Gst)))+tau_D*T_D_ss-(DebtDNR_ss)*(1-(1+R_ss)/pii_ss) - (omega_NR^2)*tau_D;
# DEN_ss     = (omega_NR*(1-omega_NR))*(((1/DC_ss)/(1-Gst)) + tau_D);
# DDNR_ss    = NUM_ss/DEN_ss;
# CCNR_ss    = (1/DC_ss)*DDNR_ss*DCNR_ss;
 
# ZC_ss      = (1/(1-Gst))*(omega_NR/CCNR_ss + (1-omega_NR));
# ZDC_ss     = tau_D*omega_NR*DCNR_ss/CCNR_ss + tau_D*(1-omega_NR)*DC_ss;
# NC_ss      = (ZDC_ss*((1-omega_NR)*(1-omega_D))/(ZDC_ss/ZC_ss))^(1/(1+sig_l_C));
# ND_ss      = ((ZDC_ss/ZC_ss)^(1/(1+sig_l_C)))*NC_ss;

# ZCNR_ss    = (1/(1-Gst))*(omega_NR + (1-omega_NR)*CCNR_ss);
# ZDCNR_ss   = tau_D*omega_NR*DCNR_ss + tau_D*(1-omega_NR)*DC_ss*CCNR_ss;
# NCNR_ss    = (ZDCNR_ss*omega_NR*(1-omega_D)/(ZDC_ss/ZC_ss))^(1/(1+sig_l_C));
# NDNR_ss    = ((ZDC_ss/ZC_ss)^(1/(1+sig_l_C)))*NCNR_ss;  
 
# L_C_ss     = ((NC_ss)^(1-omega_NR))*((NCNR_ss)^omega_NR);	
# Z_ss       = L_C_ss/phi_y;
# Z_D_ss     = Z_ss*((ND_ss/NC_ss)^(1+sig_l_C));
# C_ss       = 1/(ZC_ss/Z_ss);
# DS_ss      = DC_ss*C_ss;
# CNR_ss     = 1/(CCNR_ss/C_ss);
# DNR_ss     = DCNR_ss*CNR_ss;

# W_C_S_ss   = (NC_ss^sig_l_C)*C_ss/(1-omega_D);
# W_D_S_ss   = (ND_ss^sig_l_D)*C_ss/(1-omega_D);

# W_C_NR_ss   = (NCNR_ss^sig_l_C)*CNR_ss/(1-omega_D);
# W_D_NR_ss   = (NDNR_ss^sig_l_D)*CNR_ss/(1-omega_D);

 
# constL      = Z_D_ss*phi_y_D/(((ND_ss)^(1-omega_NR))*((NDNR_ss)^omega_NR));
# L_D_ss      = constL*(((ND_ss)^(1-omega_NR))*((NDNR_ss)^omega_NR));

# constW      = W_D_ss/((W_D_S_ss^(1-omega_NR))*(W_D_NR_ss^omega_NR)/((omega_NR^omega_NR)*((1-omega_NR)^(1-omega_NR))));

# XINR_ss     = (CNR_ss^(1-omega_D))*(DNR_ss^(omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
# UCbisNR_ss  = 1/XINR_ss;
# UCNR_ss     = UCbisNR_ss*(1-omega_D)*(CNR_ss/DNR_ss)^(-omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));			
# UC_DNR_ss   = UCbisNR_ss*omega_D*(CNR_ss/DNR_ss)^(1-omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
# Debt_ss     = (1-chi_NR)*T_D_ss*DNR_ss*(pii_ss)/(1+R_ss);

# LANDst      = LAND_LD_ss * L_D_ss;
 
# Y_ss        = omega_NR*CNR_ss+(1-omega_NR)*C_ss + Gst*Z_ss;		
 
# TRS        = 0;

# XI_ss      = (C_ss^(1-omega_D))*(DS_ss^(omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
# UCbis_ss   = 1/XI_ss;
# UC_ss      = UCbis_ss*(1-omega_D)*(C_ss/DS_ss)^(-omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
# UC_D_ss    = UCbis_ss*omega_D*(C_ss/DS_ss)^(1-omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));

# AP_ss      = (pii_ss)^(1-gamma_p)*(pii_ss)^(gamma_p-1);	
# PI_D_ss    =  pii_ss -1 ;		
# AP_D_ss    = (1+PI_D_ss)*(1+PI_D_ss)^(-gamma_p_D)*(1+PI_D_ss)^(gamma_p_D-1);
# ZP1_D_ss   = UC_ss*MC_D_ss*Z_D_ss*T_D_ss/(1-betta*xi_p_D*AP_D_ss^(miu_D/(miu_D-1)));
# ZP2_D_ss   = UC_ss*Z_D_ss*T_D_ss/(1-betta*xi_p_D*AP_D_ss^(1/(miu_D-1)));
# ZP1_ss     = UC_ss*MC_ss*Z_ss/(1-betta*xi_p*AP_ss^(miu/(miu-1)));
# ZP2_ss     = UC_ss*Z_ss/(1-betta*xi_p*AP_ss^(1/(miu-1)));
# Dp_ss      = ((1-xi_p)*(miu*(1-subv)*ZP1_ss/ZP2_ss)^(-miu/(miu-1)))/ (1-xi_p*AP_ss^(miu/(miu-1)));
# Dp_D_ss    = ((1-xi_p_D)*(miu_D*(1-subv_D)*ZP1_D_ss/ZP2_D_ss)^(-miu_D/(miu_D-1)))/(1-xi_p_D*AP_D_ss^(miu_D/(miu_D-1)));	

# W_ss       = W_C_ss;
# WC_ss      = MC_ss ;
# WD_ss      = MC_D_ss ;
# LCBAR     = UC_ss*W_C_S_ss/(miuw_C)*(NC_ss)^(-sig_l_C);
# LDBAR     = UC_ss*W_D_S_ss/(miuw_D)*(ND_ss)^(-sig_l_D);
# LC_NRBAR  = UCNR_ss*W_C_NR_ss/(miuw_C)*(NCNR_ss)^(-sig_l_C_NR);
# LD_NRBAR  = UCNR_ss*W_D_NR_ss/(miuw_D)*(NDNR_ss)^(-sig_l_D_NR);
# GDP_ss    = Z_ss  + Z_D_ss * T_D_ss ;
# TOTC_ss   = omega_NR*CNR_ss + (1-omega_NR)*C_ss;
 
# N_C_S_ss     = NC_ss;
# N_C_NR_ss    = NCNR_ss;
# N_D_S_ss     = ND_ss;
# N_D_NR_ss    = NDNR_ss;

# stuS_ss     = log(XI_ss)- LCBAR*(N_C_S_ss)^(1+sig_l_C)/(1+sig_l_C)-LDBAR*(N_D_S_ss)^(1+sig_l_D)/(1+sig_l_D);

# stuNR_ss    = log(XINR_ss)-LC_NRBAR*(N_C_NR_ss)^(1+sig_l_C_NR)/(1+sig_l_C_NR)- LD_NRBAR*(N_D_NR_ss)^(1+sig_l_D_NR)/(1+sig_l_D_NR);

# stuff_ss    = (1-omega_NR)*(1-betta)*(stuS_ss) + omega_NR*(1-betta_NR)*(stuNR_ss) ;

# well_s_ss = stuS_ss/(1-betta);
# well_b_ss = stuNR_ss/(1-betta_NR);
# well_ss = (1-omega_NR)*(1-betta)*well_s_ss + omega_NR*(1-betta_NR)*well_b_ss;

# Util_ss   = stuff_ss;
# welf_ss   = Util_ss;

# cgap_ss     = C_ss/CNR_ss;


well = (1-omega_NR)*(1-betta)*well_s + omega_NR*(1-betta_NR)*well_b;
well_s = stuS + betta*well_s(+1);
well_b = stuNR + betta_NR*well_b(+1);
Util=stuff;      
stuS=log(XI)-LCBAR*(N_C_S)^(1+sig_l_C)/(1+sig_l_C)-LDBAR*(N_D_S)^(1+sig_l_D)/(1+sig_l_D)  ;
stuNR=log(XINR)-LC_NRBAR*(N_C_NR)^(1+sig_l_C_NR)/(1+sig_l_C_NR)-LD_NRBAR*(N_D_NR)^(1+sig_l_D_NR)/(1+sig_l_D_NR);
stuff = (1-omega_NR)*(1-betta)*(stuS) + omega_NR*(1-betta_NR)*(stuNR) ;
Z=(L_C)-(phi_y-1)*Z_ss;									
Z_D=(L_D)-(phi_y_D-1)*Z_D_ss;									
AP=(pii)*(pii(-1))^(-gamma_p)*(pii_ss)^(gamma_p-1);										
AP_D=(1+PI_D)*(1+PI_D(-1))^(-gamma_p_D)*(1+PI_D_ss)^(gamma_p_D-1);										
MC=W_C;												
MC_D=W_D;											
XI=(C^(1-exp(shock_H)*omega_D))*(DS^(exp(shock_H)*omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
UCbis=1/XI;												
XINR= (CNR^(1-exp(shock_H)*omega_D))*(DNR^(exp(shock_H)*omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
UCbisNR=1/XINR;												
UC= UCbis*(1-exp(shock_H)*omega_D)*(C/DS)^(-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
UC_D= UCbis*exp(shock_H)*omega_D*(C/DS)^(1-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
Y=omega_NR*CNR+(1-omega_NR)*C + Gst*Z_ss;		
T_D*UC=UC_D+betta*(1-tau_D)*UC(+1)*T_D(+1);									
UC=UC(+1)*betta*(1+R)/(pii(+1));											
UCNR= UCbisNR*(1-exp(shock_H)*omega_D)*(CNR/DNR)^(-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));								
UC_DNR= UCbisNR*exp(shock_H)*omega_D*(CNR/DNR)^(1-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
T_D*UCNR=T_D(+1)*((pii(+1))/(1+R))*exp(shock_LTV)*(1-chi_NR)*PSI*UCNR+UC_DNR+betta_NR*(1-tau_D)*UCNR(+1)*T_D(+1);							
PSI=1-betta_NR*UCNR(+1)/UCNR*(1+R)/(pii(+1));									
Debt=exp(shock_LTV)*(1-chi_NR)*T_D(+1)*DNR*(pii(+1))/(1+R);											
CNR=-T_D*(DNR-(1-tau_D)*DNR(-1))-(1+R(-1))/(pii)*Debt(-1)+Debt+((N_C_NR*W_C_NR+N_D_NR*W_D_NR))+TRS;
Z=Dp*Y;										
Z_D=Dp_D*((1-omega_NR)*(DS-(1-tau_D)*DS(-1))+omega_NR*(DNR-(1-tau_D)*DNR(-1)));					
W_C=W_C_S^(1-omega_NR)*W_C_NR^omega_NR/(omega_NR^omega_NR*(1-omega_NR)^(1-omega_NR));												
W_D= constW*W_D_S^(1-omega_NR)*W_D_NR^omega_NR/(omega_NR^omega_NR*(1-omega_NR)^(1-omega_NR));												
L_C=(N_C_S)^(1-omega_NR)*(N_C_NR)^omega_NR;											
L_D=constL*(N_D_S)^(1-omega_NR)*(N_D_NR)^omega_NR;											
omega_NR*(N_C_S)*W_C_S=(1-omega_NR)*(N_C_NR)*W_C_NR;										
omega_NR*(N_D_S)*W_D_S=(1-omega_NR)*(N_D_NR)*W_D_NR;											
W_C_S =  (LCBAR*(N_C_S)^(sig_l_C))*(1/UC);												
W_C_NR = (LC_NRBAR*(N_C_NR)^(sig_l_C))*(1/UCNR);
W_D_S = (LDBAR*(N_D_S)^(sig_l_D))*(1/UC);
W_D_NR = (LD_NRBAR*(N_D_NR)^(sig_l_D))*(1/UCNR);	
Dp_D=(1-xi_p_D)*(miu_D*(1-subv_D)*ZP1_D/ZP2_D)^(-miu_D/(miu_D-1))+xi_p_D*Dp_D(-1)*AP_D^(miu_D/(miu_D-1));									
(miu_D*(1-subv_D)*ZP1_D/ZP2_D)^(1/(1-miu_D))*(1-xi_p_D)=1-xi_p_D*AP_D^(1/(miu_D-1));						
ZP1_D=UC*MC_D*Z_D*T_D+betta*xi_p_D*AP_D(+1)^(miu_D/(miu_D-1))*ZP1_D(+1);							
ZP2_D=UC*Z_D*T_D+betta*xi_p_D*AP_D(+1)^(1/(miu_D-1))*ZP2_D(+1);							
Dp=(1-xi_p)*(miu*(1-subv)*ZP1/ZP2)^(-miu/(miu-1))+xi_p*Dp(-1)*AP^(miu/(miu-1));	
(miu*(1-subv)*ZP1/ZP2)^(1/(1-miu))*(1-xi_p)=1-xi_p*AP^(1/(miu-1));						
ZP1=UC*MC*Z+betta*xi_p*AP(+1)^(miu/(miu-1))*ZP1(+1);							
ZP2=UC*Z+betta*xi_p*AP(+1)^(1/(miu-1))*ZP2(+1);	
T_D=T_D(-1)*(1+PI_D)/(pii);		
poly-((1+R)/(1+R_ss))+((pii/pii_ss)^((r_PI)*(1-rho)))*((GDP/GDP(-1))^(r_dy*(1-rho)))*(((1+PI_D)/(1+PI_D_ss))^(r_PID*(1-rho)))*(((1+R(-1))/(1+R_ss))^rho);										
//pii = pii_ss;
GDP=Z+Z_D*T_D;					
TOTC = omega_NR*CNR + (1-omega_NR)*C;	
//cgap=C/CNR;			
//pledge = exp(shock_LTV)*(1-chi_NR);
// Exogenous shocks;											
shock_LTV=rho_LTV*shock_LTV(-1)+E_LTV;
shock_H=rho_H*shock_H(-1)+ E_H ;
end;														


%steady;
%resid;
%check;


shocks;
var	E_LTV   = std_LTV^2;
var	E_H     = std_H^2;


end;


% =========================================================================
%  WELFARE COST CALCULATIONS
% =========================================================================

options_.nograph=1; 
options_.nocorr=1; 
options_.noprint=1; 
stoch_simul(order=2,irf=0) ;

% =======================================================================================
% HERE I CHECK IF THE PARAMETER COMBINATION GENERATES INDETERMINACY (OR OTHER PROBLEMS): 
% IN THAT CASE, I SET delta TO A DEFAULT ARTIFICIAL VALUE
% =======================================================================================

if    info(1) > 0
    delta_welf_tot = -100 ;
    delta_welf_sav = -100 ;
    delta_welf_bor = -100 ;
    Ut             = -11111;
    Uts            = -11111;
    Utnr           = -11111;

else


w1 = oo_.dr.order_var; 
windx1 = strmatch('well',M_.endo_names(w1,:),'exact');
a1=0.5*oo_.dr.ghs2(windx1);
oldindx1 = strmatch('well',M_.endo_names,'exact'); 
a11 = oo_.dr.ys(oldindx1);
Ut         =  a11 + a1 ;

ws = oo_.dr.order_var; 
windxs = strmatch('well_s',M_.endo_names(ws,:),'exact');
as=0.5*oo_.dr.ghs2(windxs);
oldindxs = strmatch('well_s',M_.endo_names,'exact'); 
as1 = oo_.dr.ys(oldindxs);
Uts            =  as1 + as ;

wnr = oo_.dr.order_var; 
windxnr = strmatch('well_b',M_.endo_names(wnr,:),'exact');
anr=0.5*oo_.dr.ghs2(windxnr);
oldindxnr = strmatch('well_b',M_.endo_names,'exact'); 
anr1 = oo_.dr.ys(oldindxnr);
Utnr       =  anr1 + anr ;

% Computing welfare gain/loss:

% (cfr. NS_2014_optimalMP.mod)
%	SOCIAL WELFARE UNDER RAMSEY POLICY         = 4.825235;
%	SAVER WELFARE UNDER RAMSEY POLICY          = 591.332855;
%	BORROWER WELFARE UNDER RAMSEY POLICY       = 11.839594;

wel_tot     = Ut;
wel_sav     = Uts;
wel_bor     = Utnr;

WELFRAM     = 4.825235;
WELFRAM_S   = 591.332855;
WELFRAM_B   = 11.839594;

 
delta_welf_sav  = 0;%1 - exp((1-betta)   *(WELFRAM_S-wel_sav));
delta_welf_bor  = 0;%1 - exp((1-betta_NR)*(WELFRAM_B-wel_bor));

end%if


% =========================================================================
%  STORAGE OF RESULTS
% =========================================================================

      pa1(i,j,m,n)      = rho_values(i);
      pa2(i,j,m,n)      = r_dy_values(j);
      pa3(i,j,m,n)      = r_PI_values(m);
      pa4(i,j,m,n)      = r_PID_values(n);

      gain_s(i,j,m,n)   = delta_welf_sav;
      gain_b(i,j,m,n)   = delta_welf_bor;  

      welf(i,j,m,n)     = Ut;
      welf_s(i,j,m,n)   = Uts;
      welf_b(i,j,m,n)   = Utnr;


      BB = BB + 1;


      waitbar(BB/tots,hw); 
      resall = [welf(:) welf_s(:) welf_b(:) gain_s(:) gain_b(:) pa1(:) pa2(:) pa3(:) pa4(:)];
       
       end;
     end;
   end; 
 end;

% =========================================================================
%  SAVING RESULTS
% =========================================================================

