

// NS 2014;

%-------------------------------------------
% written 11 June 2014
%------------------------------------------

% periods=0;
%--------------------------------------------;welf,
% Give variables names and innovations (of the shocks) names
% Notice that the AR(p) shocks are added to the structural equations;tax,
%----------------------------------------------;

var well,Util,stuS, DS,AP, MC, UCbis, Y,	Z,	AP_D,MC_D,	XI,	Z_D, 
UC,	C, UC_D, L_C, L_D,  Dp, pii, ZP1, ZP2, Dp_D, PI_D, ZP1_D,	ZP2_D, W_C,	W_D, W_C_S,	N_C_S,	W_D_S, N_D_S,  T_D, GDP,	R, shock_H;				
varexo E_H;  

%-----------------------------------------------;
% GIVE PARAMETER'S NAMES
%----------------------------------------------;
parameters constL, constW, nbeta, miu, miuw_C, miuw_D,	subv,	betta,	sig_c,	phi_y,	gamma_p,	xi_p,	sig_l_C,	r_PI,	r_dy,	rho,	Lst,	tau_D,	hetha_D,	omega_D,	chi_NR,	omega_NR,	phi_y_D,	alph_D, xi_p_D,	gamma_p_D,	miu_D,	subv_D,	rho_LTV,	rho_H,	alph_LAN, diff_betta,	r_PID,	betta_NR,	sig_l_D, sig_l_C_NR,	sig_l_D_NR,	
LANDst, Z_ss, Z_D_ss, Gst, TRS, R_ss, GDP_ss, pii_ss, PI_D_ss, LCBAR,  LDBAR,  LC_NRBAR,  LD_NRBAR, std_LTV, std_H, poly;			
										
									
%---------------------------------------------------;
% start here 
%---------------------------------------------------;
model;
well = Util + betta*well(+1);
Util=stuS;      
stuS=log(XI)-LCBAR*(N_C_S)^(1+sig_l_C)/(1+sig_l_C)-LDBAR*(N_D_S)^(1+sig_l_D)/(1+sig_l_D)  ;
Z=(L_C)-(phi_y-1)*Z_ss;									
Z_D=(L_D)-(phi_y_D-1)*Z_D_ss;									
AP=(pii)*(pii(-1))^(-gamma_p)*(pii_ss)^(gamma_p-1);										
AP_D=(1+PI_D)*(1+PI_D(-1))^(-gamma_p_D)*(1+PI_D_ss)^(gamma_p_D-1);										
MC=W_C;												
MC_D=W_D;											
%XI=(C^(1-exp(shock_H)*omega_D))*(DS^(exp(shock_H)*omega_D))*(1/((exp(shock_H)*omega_D^(exp(shock_H)*omega_D))*((1-exp(shock_H)*omega_D)^(1-(exp(shock_H)*omega_D)))));
%UCbis=1/XI;												
%UC= UCbis*(1-exp(shock_H)*omega_D)*(C/DS)^(-exp(shock_H)*omega_D)*(1/((exp(shock_H)*omega_D^(exp(shock_H)*omega_D))*((1-exp(shock_H)*omega_D)^(1-exp(shock_H)*omega_D))));
%UC_D= UCbis*exp(shock_H)*omega_D*(C/DS)^(1-exp(shock_H)*omega_D)*(1/((exp(shock_H)*omega_D^(exp(shock_H)*omega_D))*((1-exp(shock_H)*omega_D)^(1-exp(shock_H)*omega_D))));
XI=(C^(1-exp(shock_H)*omega_D))*(DS^(exp(shock_H)*omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
UCbis=1/XI;												
UC= UCbis*(1-exp(shock_H)*omega_D)*(C/DS)^(-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
UC_D= UCbis*exp(shock_H)*omega_D*(C/DS)^(1-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
Y=C + Gst*Z_ss;		
T_D*UC=UC_D+betta*(1-tau_D)*UC(+1)*T_D(+1);									
UC=UC(+1)*betta*(1+R)/(pii(+1));											
Z=Dp*Y;										
Z_D=(DS-(1-tau_D)*DS(-1));					
W_C=W_C_S;												
W_D= constW*W_D_S;												
L_C=(N_C_S);											
L_D=constL*(N_D_S);											
W_C_S =  (LCBAR*(N_C_S)^(sig_l_C))*(1/UC);												
W_D_S = (LDBAR*(N_D_S)^(sig_l_D))*(1/UC);
Dp_D=(1-xi_p_D)*(miu_D*(1-subv_D)*ZP1_D/ZP2_D)^(-miu_D/(miu_D-1))+xi_p_D*Dp_D(-1)*AP_D^(miu_D/(miu_D-1));									
(miu_D*(1-subv_D)*ZP1_D/ZP2_D)^(1/(1-miu_D))*(1-xi_p_D)=1-xi_p_D*AP_D^(1/(miu_D-1));						
ZP1_D=UC*MC_D*Z_D*T_D+betta*xi_p_D*AP_D(+1)^(miu_D/(miu_D-1))*ZP1_D(+1);							
ZP2_D=UC*Z_D*T_D+betta*xi_p_D*AP_D(+1)^(1/(miu_D-1))*ZP2_D(+1);							
Dp=(1-xi_p)*(miu*(1-subv)*ZP1/ZP2)^(-miu/(miu-1))+xi_p*Dp(-1)*AP^(miu/(miu-1));	
(miu*(1-subv)*ZP1/ZP2)^(1/(1-miu))*(1-xi_p)=1-xi_p*AP^(1/(miu-1));						
ZP1=UC*MC*Z+betta*xi_p*AP(+1)^(miu/(miu-1))*ZP1(+1);							
ZP2=UC*Z+betta*xi_p*AP(+1)^(1/(miu-1))*ZP2(+1);	
T_D=T_D(-1)*(1+PI_D)/(pii);		
poly-((1+R)/(1+R_ss))+((pii/pii_ss)^((r_PI)*(1-rho)))*((GDP/GDP(-1))^(r_dy*(1-rho)))*(((1+PI_D)/(1+PI_D_ss))^(r_PID*(1-rho)))*(((1+R(-1))/(1+R_ss))^rho);										
//pii = pii_ss;
GDP=Z+Z_D*T_D;					
// Exogenous shocks;											
shock_H=rho_H*shock_H(-1)+E_H;
end;					


steady;
resid;
check;


shocks;
var	E_H     = std_H^2;
end;


% options_.nograph = 1;
% stoch_simul(order=1,irf=120);%,pruning,periods = 5000);
% figure
% subplot(6,2,1)
% plot(oo_.irfs.R_E_H,'r','LineWidth',2)
% legend('Policy rate')
% subplot(6,2,2)
% plot(oo_.irfs.Y_E_H,'b','LineWidth',2)
% legend('GDP')
% subplot(6,2,3)
% plot(oo_.irfs.pii_E_H,'k','LineWidth',2)
% legend('inflation')
% %subplot(6,2,4)
% %plot(oo_.irfs.T_D_E_H,'b-o','LineWidth',2)
% %legend('house price')
% subplot(6,2,4)
% plot(oo_.irfs.PI_D_E_H,'b-o','LineWidth',2)
% legend('house price inflation')
% subplot(6,2,5)
% plot(oo_.irfs.C_E_H,'r-x','LineWidth',2)
% legend('Consumption')
% subplot(6,2,6)
% %plot(oo_.irfs.DS_E_H,'r-x','LineWidth',2)
% %legend('Housing stock')
% plot(oo_.irfs.XI_E_H,'r-x','LineWidth',2)
% legend('Overall consumption basket')
% subplot(6,2,7)
% plot(oo_.irfs.Z_E_H,'r-x','LineWidth',2)
% legend('Nondurable production')
% subplot(6,2,8)
% plot(oo_.irfs.Z_D_E_H,'r-x','LineWidth',2)
% legend('Durable production')
% subplot(6,2,9)
% plot(oo_.irfs.L_C_E_H,'r-x','LineWidth',2)
% legend('labor c')
% subplot(6,2,10)
% plot(oo_.irfs.L_D_E_H,'r-x','LineWidth',2)
% legend('labor d')
% subplot(6,2,11)
% plot(oo_.irfs.W_C_E_H,'r-x','LineWidth',2)
% legend('wage c')
% subplot(6,2,12)
% plot(oo_.irfs.W_D_E_H,'r-x','LineWidth',2)
% legend('wage d')

%==========================================================================
stoch_simul(order=2,irf=0);

betta = 0.99;

w1 = oo_.dr.order_var; 
windx1 = strmatch('well',M_.endo_names(w1,:),'exact');
a1=0.5*oo_.dr.ghs2(windx1);
oldindx1 = strmatch('well',M_.endo_names,'exact'); 
a11 = oo_.dr.ys(oldindx1);
Ut         =  a11 + a1 ;

w2 = oo_.dr.order_var; 
windx2 = strmatch('Util',M_.endo_names(w2,:),'exact');
a2=0.5*oo_.dr.ghs2(windx2);
oldindx2 = strmatch('Util',M_.endo_names,'exact'); 
a22 = oo_.dr.ys(oldindx2);
Uti         =  a22 + a2 ;

wel         = Ut;
WELFRAM     = 657.638627;
  
delta_welf  = 1 - exp((1-betta)   *(WELFRAM-wel));
 
  
 
  fprintf	('	SOCIAL WELFARE UNDER RAMSEY POLICY          = ')	;	fprintf	('%f',	WELFRAM);	disp(';')
  fprintf	('	SOCIAL WELFARE UNDER SIMPLE RULE            = ')	;	fprintf	('%f',	Ut	);	disp(';')
  fprintf	('	WELFARE GAIN                                = ')	;	fprintf	('%f',	delta_welf	);	disp(';')
  