// This is an extension of the file NS_2014.mod that;
// eliminates from the forward looking equations backward looking variables;
// it does this by generating dummy variables ;
// version: 07-Aug-2014 10:12:13;
// NS 2014;;
%-------------------------------------------;
% written 11 June 2014;
%------------------------------------------;
% periods=0;;
%--------------------------------------------;welf,;
% Give variables names and innovations (of the shocks) names;
% Notice that the AR(p) shocks are added to the structural equations;tax,;
%----------------------------------------------;;
var  AP,AP_D,C,CNR,DNR,DS,Debt,Dp,Dp_D,GDP,L_C,L_D,MC,MC_D,N_C_NR,N_C_S,N_D_NR,N_D_S,PI_D,PSI,R,RR,TOTC,T_D,UC,UCNR,UC_D,UC_DNR,UCbis,UCbisNR,Util,W_C,W_C_NR,W_C_S,W_D,W_D_NR,W_D_S,XI,XINR,Y,Z,ZP1,ZP1_D,ZP2,ZP2_D,Z_D,pii,stuNR,stuS,stuff,well,well_b,well_s, 
ramsey1,ramsey2,ramsey3,ramsey4,ramsey5,ramsey6,ramsey7,ramsey8,ramsey9,ramsey10,ramsey11,ramsey12,ramsey13,ramsey14,ramsey15,ramsey16,ramsey17,ramsey18,ramsey19,ramsey20,ramsey21,ramsey22,ramsey23,ramsey24,ramsey25,ramsey26,ramsey27,ramsey28,ramsey29,ramsey30,ramsey31,ramsey32,ramsey33,ramsey34,ramsey35,ramsey36,ramsey37,ramsey38,ramsey39,ramsey40,ramsey41,ramsey42,ramsey43,ramsey44,ramsey45,ramsey46,ramsey47,ramsey48,ramsey49,ramsey50,ramsey51,
shock_H,shock_LTV;
// ;
//P_L,pledge, cgap, stuff,
varexo E_LTV,E_H ;  
%-----------------------------------------------;
% GIVE PARAMETER'S NAMES
%----------------------------------------------;
parameters constL, constW, nbeta, mu, muw_C, muw_D,	subv,	betta,	sig_c,	phi_y,	gamma_p,	xi_p,	sig_l_C,	r_PI,	r_dy,	rho,	Lst,	tau_D,	hetha_D,	omega_D,	chi_NR,	omega_NR,	phi_y_D,	alph_D, xi_p_D,	gamma_p_D,	mu_D,	subv_D,	rho_LTV,	rho_H,	alph_LAN, diff_betta,	r_PID,	betta_NR,	sig_l_D, sig_l_C_NR,	sig_l_D_NR,	
LANDst, Z_ss, Z_D_ss, Gst, TRS, R_ss, GDP_ss, pii_ss, PI_D_ss, LCBAR,  LDBAR,  LC_NRBAR,  LD_NRBAR, std_LTV, std_H, poly, std_P;			
										
									
%---------------------------------------------------;
% start here 
%---------------------------------------------------;
parameters nash_param aleph;  // ;
model;
// ;
// Welfare;
Util=stuff;
// Policy Rule;
// poly-((1+R)/(1+R_ss))+((pii/pii_ss)^((r_PI)*(1-rho)))*((GDP/GDP(-1))^(r_dy*(1-rho)))*(((1+PI_D)/(1+PI_D_ss))^(r_PID*(1-rho)))*(((1+R(-1))/(1+R_ss))^rho);
// ;
well_s-(stuS+betta*well_s(+1))=0;
well_b-(stuNR+betta_NR*well_b(+1))=0;
T_D*UC-(UC_D+betta*(1-tau_D)*UC(+1)*T_D(+1))=0;
UC-(UC(+1)*betta*(1+R)/(pii(+1)))=0;
T_D*UCNR-(T_D(+1)*((pii(+1))/(1+R))*exp(shock_LTV)*(1-chi_NR)*PSI*UCNR+UC_DNR+betta_NR*(1-tau_D)*UCNR(+1)*T_D(+1))=0;
PSI-(1-betta_NR*UCNR(+1)/UCNR*(1+R)/(pii(+1)))=0;
Debt-(exp(shock_LTV)*(1-chi_NR)*T_D(+1)*DNR*(pii(+1))/(1+R))=0;
ZP1_D-(UC*MC_D*Z_D*T_D+betta*xi_p_D*AP_D(+1)^(mu_D/(mu_D-1))*ZP1_D(+1))=0;
ZP2_D-(UC*Z_D*T_D+betta*xi_p_D*AP_D(+1)^(1/(mu_D-1))*ZP2_D(+1))=0;
ZP1-(UC*MC*Z+betta*xi_p*AP(+1)^(mu/(mu-1))*ZP1(+1))=0;
ZP2-(UC*Z+betta*xi_p*AP(+1)^(1/(mu-1))*ZP2(+1))=0;
RR-((R/pii(+1)))=0;
// ;
well-((1-omega_NR)*(1-betta)*well_s+omega_NR*(1-betta_NR)*well_b)=0                                                          ;
stuS-(log(XI)-LCBAR*(N_C_S)^(1+sig_l_C)/(1+sig_l_C)-LDBAR*(N_D_S)^(1+sig_l_D)/(1+sig_l_D))=0                                 ;
stuNR-(log(XINR)-LC_NRBAR*(N_C_NR)^(1+sig_l_C_NR)/(1+sig_l_C_NR)-LD_NRBAR*(N_D_NR)^(1+sig_l_D_NR)/(1+sig_l_D_NR))=0          ;
stuff-((1-omega_NR)*(1-betta)*(stuS)+omega_NR*(1-betta_NR)*(stuNR))=0                                                        ;
Z-((L_C)-(phi_y-1)*Z_ss)=0                                                                                                   ;
Z_D-((L_D)-(phi_y_D-1)*Z_D_ss)=0                                                                                             ;
AP-((pii)*(pii(-1))^(-gamma_p)*(pii_ss)^(gamma_p-1))=0                                                                       ;
AP_D-((1+PI_D)*(1+PI_D(-1))^(-gamma_p_D)*(1+PI_D_ss)^(gamma_p_D-1))=0                                                        ;
MC-(W_C)=0                                                                                                                   ;
MC_D-(W_D)=0                                                                                                                 ;
XI-((C^(1-exp(shock_H)*omega_D))*(DS^(exp(shock_H)*omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D)))))=0            ;
UCbis-(1/XI)=0                                                                                                               ;
XINR-((CNR^(1-exp(shock_H)*omega_D))*(DNR^(exp(shock_H)*omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D)))))=0       ;
UCbisNR-(1/XINR)=0                                                                                                           ;
UC-(UCbis*(1-exp(shock_H)*omega_D)*(C/DS)^(-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D)))))=0       ;
UC_D-(UCbis*exp(shock_H)*omega_D*(C/DS)^(1-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D)))))=0        ;
Y-(omega_NR*CNR+(1-omega_NR)*C+Gst*Z_ss)=0                                                                                   ;
UCNR-(UCbisNR*(1-exp(shock_H)*omega_D)*(CNR/DNR)^(-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D)))))=0;
UC_DNR-(UCbisNR*exp(shock_H)*omega_D*(CNR/DNR)^(1-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D)))))=0 ;
CNR-(-T_D*(DNR-(1-tau_D)*DNR(-1))-(1+R(-1))/(pii)*Debt(-1)+Debt+((N_C_NR*W_C_NR+N_D_NR*W_D_NR))+TRS)=0                       ;
Z-(Dp*Y)=0                                                                                                                   ;
Z_D-(Dp_D*((1-omega_NR)*(DS-(1-tau_D)*DS(-1))+omega_NR*(DNR-(1-tau_D)*DNR(-1))))=0                                           ;
W_C-(W_C_S^(1-omega_NR)*W_C_NR^omega_NR/(omega_NR^omega_NR*(1-omega_NR)^(1-omega_NR)))=0                                     ;
W_D-(constW*W_D_S^(1-omega_NR)*W_D_NR^omega_NR/(omega_NR^omega_NR*(1-omega_NR)^(1-omega_NR)))=0                              ;
L_C-((N_C_S)^(1-omega_NR)*(N_C_NR)^omega_NR)=0                                                                               ;
L_D-(constL*(N_D_S)^(1-omega_NR)*(N_D_NR)^omega_NR)=0                                                                        ;
omega_NR*(N_C_S)*W_C_S-((1-omega_NR)*(N_C_NR)*W_C_NR)=0                                                                      ;
omega_NR*(N_D_S)*W_D_S-((1-omega_NR)*(N_D_NR)*W_D_NR)=0                                                                      ;
W_C_S-((LCBAR*(N_C_S)^(sig_l_C))*(1/UC))=0                                                                                   ;
W_C_NR-((LC_NRBAR*(N_C_NR)^(sig_l_C))*(1/UCNR))=0                                                                            ;
W_D_S-((LDBAR*(N_D_S)^(sig_l_D))*(1/UC))=0                                                                                   ;
W_D_NR-((LD_NRBAR*(N_D_NR)^(sig_l_D))*(1/UCNR))=0                                                                            ;
Dp_D-((1-xi_p_D)*(mu_D*(1-subv_D)*ZP1_D/ZP2_D)^(-mu_D/(mu_D-1))+xi_p_D*Dp_D(-1)*AP_D^(mu_D/(mu_D-1)))=0                      ;
(mu_D*(1-subv_D)*ZP1_D/ZP2_D)^(1/(1-mu_D))*(1-xi_p_D)-(1-xi_p_D*AP_D^(1/(mu_D-1)))=0                                         ;
Dp-((1-xi_p)*(mu*(1-subv)*ZP1/ZP2)^(-mu/(mu-1))+xi_p*Dp(-1)*AP^(mu/(mu-1)))=0                                                ;
(mu*(1-subv)*ZP1/ZP2)^(1/(1-mu))*(1-xi_p)-(1-xi_p*AP^(1/(mu-1)))=0                                                           ;
T_D-(T_D(-1)*(1+PI_D)/(pii))=0                                                                                               ;
GDP-(Z+Z_D*T_D)=0                                                                                                            ;
TOTC-(omega_NR*CNR+(1-omega_NR)*C)=0                                                                                         ;
// FOC of Lagrange problem ;
0+ramsey19*(1)+ramsey47*(-(AP^(mu/(mu - 1) - 1)*Dp(-1)*mu*xi_p)/(mu - 1))+ramsey48*((AP^(1/(mu - 1) - 1)*xi_p)/(mu - 1))+nbeta*(0)+1/nbeta*ramsey10(-1)*(-(AP^(mu/(mu - 1) - 1)*ZP1*betta*mu*xi_p)/(mu - 1))+1/nbeta*ramsey11(-1)*(-(AP^(1/(mu - 1) - 1)*ZP2*betta*xi_p)/(mu - 1))=0;
0+ramsey20*(1)+ramsey45*(-(AP_D^(mu_D/(mu_D - 1) - 1)*Dp_D(-1)*mu_D*xi_p_D)/(mu_D - 1))+ramsey46*((AP_D^(1/(mu_D - 1) - 1)*xi_p_D)/(mu_D - 1))+nbeta*(0)+1/nbeta*ramsey8(-1)*(-(AP_D^(mu_D/(mu_D - 1) - 1)*ZP1_D*betta*mu_D*xi_p_D)/(mu_D - 1))+1/nbeta*ramsey9(-1)*(-(AP_D^(1/(mu_D - 1) - 1)*ZP2_D*betta*xi_p_D)/(mu_D - 1))=0;
0+ramsey23*((DS^(omega_D*exp(shock_H))*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(C^(omega_D*exp(shock_H))*omega_D^omega_D))+ramsey27*(-(UCbis*omega_D*exp(shock_H)*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(DS*omega_D^omega_D*(C/DS)^(omega_D*exp(shock_H) + 1)))+ramsey28*((UCbis*omega_D*exp(shock_H)*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(DS*omega_D^omega_D*(C/DS)^(omega_D*exp(shock_H))))+ramsey29*(omega_NR - 1)+ramsey51*(omega_NR - 1)+nbeta*(0)=0;
0+ramsey25*((DNR^(omega_D*exp(shock_H))*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(CNR^(omega_D*exp(shock_H))*omega_D^omega_D))+ramsey29*(-omega_NR)+ramsey30*(-(UCbisNR*omega_D*exp(shock_H)*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(DNR*omega_D^omega_D*(CNR/DNR)^(omega_D*exp(shock_H) + 1)))+ramsey31*((UCbisNR*omega_D*exp(shock_H)*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(DNR*omega_D^omega_D*(CNR/DNR)^(omega_D*exp(shock_H))))+ramsey32*(1)+ramsey51*(-omega_NR)+nbeta*(0)=0;
0+ramsey7*(1)+ramsey32*(-1)+nbeta*(0)+nbeta*ramsey32(+1)*((R + 1)/pii(+1))=0;
0+ramsey7*((T_D(+1)*pii(+1)*exp(shock_LTV)*(chi_NR - 1))/(R + 1))+ramsey25*(-(CNR^(1 - omega_D*exp(shock_H))*DNR^(omega_D*exp(shock_H) - 1)*omega_D*exp(shock_H)*(1 - omega_D)^(omega_D - 1))/omega_D^omega_D)+ramsey30*((CNR*UCbisNR*omega_D*exp(shock_H)*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(DNR^2*omega_D^omega_D*(CNR/DNR)^(omega_D*exp(shock_H) + 1)))+ramsey31*(-(CNR*UCbisNR*omega_D*exp(shock_H)*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(DNR^2*omega_D^omega_D*(CNR/DNR)^(omega_D*exp(shock_H))))+ramsey32*(T_D)+ramsey34*(-Dp_D*omega_NR)+nbeta*(0)+nbeta*ramsey32(+1)*(T_D(+1)*(tau_D - 1))+nbeta*ramsey34(+1)*(-Dp_D(+1)*omega_NR*(tau_D - 1))=0;
0+ramsey33*(-Y)+ramsey47*(1)+nbeta*(0)+nbeta*ramsey47(+1)*(-AP(+1)^(mu/(mu - 1))*xi_p)=0;
0+ramsey34*((DS + DS(-1)*(tau_D - 1))*(omega_NR - 1) - omega_NR*(DNR + DNR(-1)*(tau_D - 1)))+ramsey45*(1)+nbeta*(0)+nbeta*ramsey45(+1)*(-AP_D(+1)^(mu_D/(mu_D - 1))*xi_p_D)=0;
0+ramsey23*(-(C^(1 - omega_D*exp(shock_H))*DS^(omega_D*exp(shock_H) - 1)*omega_D*exp(shock_H)*(1 - omega_D)^(omega_D - 1))/omega_D^omega_D)+ramsey27*((C*UCbis*omega_D*exp(shock_H)*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(DS^2*omega_D^omega_D*(C/DS)^(omega_D*exp(shock_H) + 1)))+ramsey28*(-(C*UCbis*omega_D*exp(shock_H)*(omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(DS^2*omega_D^omega_D*(C/DS)^(omega_D*exp(shock_H))))+ramsey34*(Dp_D*(omega_NR - 1))+nbeta*(0)+nbeta*ramsey34(+1)*(Dp_D(+1)*(omega_NR - 1)*(tau_D - 1))=0;
0+ramsey50*(1)+nbeta*(0)=0;
0+ramsey17*(-1)+ramsey37*(1)+nbeta*(0)=0;
0+ramsey18*(-1)+ramsey38*(1)+nbeta*(0)=0;
0+ramsey10*(-UC*Z)+ramsey21*(1)+nbeta*(0)=0;
0+ramsey8*(-T_D*UC*Z_D)+ramsey22*(1)+nbeta*(0)=0;
0+ramsey15*(LC_NRBAR*N_C_NR^sig_l_C_NR)+ramsey32*(-W_C_NR)+ramsey37*(-N_C_S^(1 - omega_NR)*N_C_NR^(omega_NR - 1)*omega_NR)+ramsey39*(W_C_NR*(omega_NR - 1))+ramsey42*(-(LC_NRBAR*N_C_NR^(sig_l_C - 1)*sig_l_C)/UCNR)+nbeta*(0)=0;
0+ramsey14*(LCBAR*N_C_S^sig_l_C)+ramsey37*((N_C_NR^omega_NR*(omega_NR - 1))/N_C_S^omega_NR)+ramsey39*(W_C_S*omega_NR)+ramsey41*(-(LCBAR*N_C_S^(sig_l_C - 1)*sig_l_C)/UC)+nbeta*(0)=0;
0+ramsey15*(LD_NRBAR*N_D_NR^sig_l_D_NR)+ramsey32*(-W_D_NR)+ramsey38*(-N_D_S^(1 - omega_NR)*N_D_NR^(omega_NR - 1)*constL*omega_NR)+ramsey40*(W_D_NR*(omega_NR - 1))+ramsey44*(-(LD_NRBAR*N_D_NR^(sig_l_D - 1)*sig_l_D)/UCNR)+nbeta*(0)=0;
0+ramsey14*(LDBAR*N_D_S^sig_l_D)+ramsey38*((N_D_NR^omega_NR*constL*(omega_NR - 1))/N_D_S^omega_NR)+ramsey40*(W_D_S*omega_NR)+ramsey43*(-(LDBAR*N_D_S^(sig_l_D - 1)*sig_l_D)/UC)+nbeta*(0)=0;
0+ramsey20*(-(PI_D_ss + 1)^(gamma_p_D - 1)/(PI_D(-1) + 1)^gamma_p_D)+ramsey49*(-T_D(-1)/pii)+nbeta*(0)+nbeta*ramsey20(+1)*((gamma_p_D*(PI_D_ss + 1)^(gamma_p_D - 1)*(PI_D(+1) + 1))/(PI_D + 1)^(gamma_p_D + 1))=0;
0+ramsey19*(-pii_ss^(gamma_p - 1)/pii(-1)^gamma_p)+ramsey32*(-(Debt(-1)*(R(-1) + 1))/pii^2)+ramsey49*((T_D(-1)*(PI_D + 1))/pii^2)+nbeta*(0)+1/nbeta*ramsey4(-1)*((UC*betta*(R(-1) + 1))/pii^2)+1/nbeta*ramsey5(-1)*((PSI(-1)*T_D*UCNR(-1)*exp(shock_LTV(-1))*(chi_NR - 1))/(R(-1) + 1))+1/nbeta*ramsey6(-1)*(-(UCNR*betta_NR*(R(-1) + 1))/(UCNR(-1)*pii^2))+1/nbeta*ramsey7(-1)*((DNR(-1)*T_D*exp(shock_LTV(-1))*(chi_NR - 1))/(R(-1) + 1))+1/nbeta*ramsey12(-1)*(R(-1)/pii^2)+nbeta*ramsey19(+1)*((gamma_p*pii_ss^(gamma_p - 1)*pii(+1))/pii^(gamma_p + 1))=0;
0+ramsey5*((T_D(+1)*UCNR*pii(+1)*exp(shock_LTV)*(chi_NR - 1))/(R + 1))+ramsey6*(1)+nbeta*(0)=0;
0+ramsey4*(-(UC(+1)*betta)/pii(+1))+ramsey5*(-(PSI*T_D(+1)*UCNR*pii(+1)*exp(shock_LTV)*(chi_NR - 1))/(R + 1)^2)+ramsey6*((UCNR(+1)*betta_NR)/(UCNR*pii(+1)))+ramsey7*(-(DNR*T_D(+1)*pii(+1)*exp(shock_LTV)*(chi_NR - 1))/(R + 1)^2)+ramsey12*(-1/pii(+1))+nbeta*(0)+nbeta*ramsey32(+1)*(Debt/pii(+1))=0;
0+ramsey12*(1)+nbeta*(0)=0;
1+ramsey16*(1)+nbeta*(0)=0;
0+ramsey2*(-1)+ramsey15*(1)+ramsey16*(omega_NR*(betta_NR - 1))+nbeta*(0)=0;
0+ramsey1*(-1)+ramsey14*(1)+ramsey16*(-(betta - 1)*(omega_NR - 1))+nbeta*(0)=0;
0+ramsey3*(UC)+ramsey5*(UCNR)+ramsey8*(-MC_D*UC*Z_D)+ramsey9*(-UC*Z_D)+ramsey32*(DNR + DNR(-1)*(tau_D - 1))+ramsey49*(1)+ramsey50*(-Z_D)+nbeta*(0)+1/nbeta*ramsey3(-1)*(UC*betta*(tau_D - 1))+1/nbeta*ramsey5(-1)*(UCNR*betta_NR*(tau_D - 1) + (PSI(-1)*UCNR(-1)*pii*exp(shock_LTV(-1))*(chi_NR - 1))/(R(-1) + 1))+1/nbeta*ramsey7(-1)*((DNR(-1)*pii*exp(shock_LTV(-1))*(chi_NR - 1))/(R(-1) + 1))+nbeta*ramsey49(+1)*(-(PI_D(+1) + 1)/pii(+1))=0;
0+ramsey51*(1)+nbeta*(0)=0;
0+ramsey3*(T_D)+ramsey4*(1)+ramsey8*(-MC_D*T_D*Z_D)+ramsey9*(-T_D*Z_D)+ramsey10*(-MC*Z)+ramsey11*(-Z)+ramsey27*(1)+ramsey41*((LCBAR*N_C_S^sig_l_C)/UC^2)+ramsey43*((LDBAR*N_D_S^sig_l_D)/UC^2)+nbeta*(0)+1/nbeta*ramsey3(-1)*(T_D*betta*(tau_D - 1))+1/nbeta*ramsey4(-1)*(-(betta*(R(-1) + 1))/pii)=0;
0+ramsey3*(-1)+ramsey28*(1)+nbeta*(0)=0;
0+ramsey5*(-1)+ramsey31*(1)+nbeta*(0)=0;
0+ramsey24*(1)+ramsey27*(((omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(omega_D^omega_D*(C/DS)^(omega_D*exp(shock_H))))+ramsey28*(-(omega_D*exp(shock_H)*(C/DS)^(1 - omega_D*exp(shock_H))*(1 - omega_D)^(omega_D - 1))/omega_D^omega_D)+nbeta*(0)=0;
0+ramsey26*(1)+ramsey30*(((omega_D*exp(shock_H) - 1)*(1 - omega_D)^(omega_D - 1))/(omega_D^omega_D*(CNR/DNR)^(omega_D*exp(shock_H))))+ramsey31*(-(omega_D*exp(shock_H)*(CNR/DNR)^(1 - omega_D*exp(shock_H))*(1 - omega_D)^(omega_D - 1))/omega_D^omega_D)+nbeta*(0)=0;
0+ramsey5*(T_D + (PSI*T_D(+1)*pii(+1)*exp(shock_LTV)*(chi_NR - 1))/(R + 1))+ramsey6*(-(UCNR(+1)*betta_NR*(R + 1))/(UCNR^2*pii(+1)))+ramsey30*(1)+ramsey42*((LC_NRBAR*N_C_NR^sig_l_C)/UCNR^2)+ramsey44*((LD_NRBAR*N_D_NR^sig_l_D)/UCNR^2)+nbeta*(0)+1/nbeta*ramsey5(-1)*(T_D*betta_NR*(tau_D - 1))+1/nbeta*ramsey6(-1)*((betta_NR*(R(-1) + 1))/(UCNR(-1)*pii))=0;
0+ramsey21*(-1)+ramsey35*(1)+nbeta*(0)=0;
0+ramsey32*(-N_C_NR)+ramsey35*(-(W_C_S^(1 - omega_NR)*W_C_NR^(omega_NR - 1)*omega_NR*(1 - omega_NR)^(omega_NR - 1))/omega_NR^omega_NR)+ramsey39*(N_C_NR*(omega_NR - 1))+ramsey42*(1)+nbeta*(0)=0;
0+ramsey35*((W_C_NR^omega_NR*(omega_NR - 1)*(1 - omega_NR)^(omega_NR - 1))/(W_C_S^omega_NR*omega_NR^omega_NR))+ramsey39*(N_C_S*omega_NR)+ramsey41*(1)+nbeta*(0)=0;
0+ramsey22*(-1)+ramsey36*(1)+nbeta*(0)=0;
0+ramsey32*(-N_D_NR)+ramsey36*(-(W_D_S^(1 - omega_NR)*W_D_NR^(omega_NR - 1)*constW*omega_NR*(1 - omega_NR)^(omega_NR - 1))/omega_NR^omega_NR)+ramsey40*(N_D_NR*(omega_NR - 1))+ramsey44*(1)+nbeta*(0)=0;
0+ramsey36*((W_D_NR^omega_NR*constW*(omega_NR - 1)*(1 - omega_NR)^(omega_NR - 1))/(W_D_S^omega_NR*omega_NR^omega_NR))+ramsey40*(N_D_S*omega_NR)+ramsey43*(1)+nbeta*(0)=0;
0+ramsey13*(1)+nbeta*(0)=0;
0+ramsey2*(1)+ramsey13*(omega_NR*(betta_NR - 1))+nbeta*(0)+1/nbeta*ramsey2(-1)*(-betta_NR)=0;
0+ramsey1*(1)+ramsey13*(-(betta - 1)*(omega_NR - 1))+nbeta*(0)+1/nbeta*ramsey1(-1)*(-betta)=0;
0+ramsey14*(-1/XI)+ramsey23*(1)+ramsey24*(1/XI^2)+nbeta*(0)=0;
0+ramsey15*(-1/XINR)+ramsey25*(1)+ramsey26*(1/XINR^2)+nbeta*(0)=0;
0+ramsey29*(1)+ramsey33*(-Dp)+nbeta*(0)=0;
0+ramsey10*(-MC*UC)+ramsey11*(-UC)+ramsey17*(1)+ramsey33*(1)+ramsey50*(-1)+nbeta*(0)=0;
0+ramsey8*(-MC_D*T_D*UC)+ramsey9*(-T_D*UC)+ramsey18*(1)+ramsey34*(1)+ramsey50*(-T_D)+nbeta*(0)=0;
0+ramsey10*(1)+ramsey47*((mu^2*(subv - 1)*(xi_p - 1))/(ZP2*(mu - 1)*(-(ZP1*mu*(subv - 1))/ZP2)^(mu/(mu - 1) + 1)))+ramsey48*(-(mu*(subv - 1)*(xi_p - 1))/(ZP2*(mu - 1)*(-(ZP1*mu*(subv - 1))/ZP2)^(1/(mu - 1) + 1)))+nbeta*(0)+1/nbeta*ramsey10(-1)*(-AP^(mu/(mu - 1))*betta*xi_p)=0;
0+ramsey8*(1)+ramsey45*((mu_D^2*(subv_D - 1)*(xi_p_D - 1))/(ZP2_D*(mu_D - 1)*(-(ZP1_D*mu_D*(subv_D - 1))/ZP2_D)^(mu_D/(mu_D - 1) + 1)))+ramsey46*(-(mu_D*(subv_D - 1)*(xi_p_D - 1))/(ZP2_D*(mu_D - 1)*(-(ZP1_D*mu_D*(subv_D - 1))/ZP2_D)^(1/(mu_D - 1) + 1)))+nbeta*(0)+1/nbeta*ramsey8(-1)*(-AP_D^(mu_D/(mu_D - 1))*betta*xi_p_D)=0;
0+ramsey11*(1)+ramsey47*(-(ZP1*mu^2*(subv - 1)*(xi_p - 1))/(ZP2^2*(mu - 1)*(-(ZP1*mu*(subv - 1))/ZP2)^(mu/(mu - 1) + 1)))+ramsey48*((ZP1*mu*(subv - 1)*(xi_p - 1))/(ZP2^2*(mu - 1)*(-(ZP1*mu*(subv - 1))/ZP2)^(1/(mu - 1) + 1)))+nbeta*(0)+1/nbeta*ramsey11(-1)*(-AP^(1/(mu - 1))*betta*xi_p)=0;
0+ramsey9*(1)+ramsey45*(-(ZP1_D*mu_D^2*(subv_D - 1)*(xi_p_D - 1))/(ZP2_D^2*(mu_D - 1)*(-(ZP1_D*mu_D*(subv_D - 1))/ZP2_D)^(mu_D/(mu_D - 1) + 1)))+ramsey46*((ZP1_D*mu_D*(subv_D - 1)*(xi_p_D - 1))/(ZP2_D^2*(mu_D - 1)*(-(ZP1_D*mu_D*(subv_D - 1))/ZP2_D)^(1/(mu_D - 1) + 1)))+nbeta*(0)+1/nbeta*ramsey9(-1)*(-AP_D^(1/(mu_D - 1))*betta*xi_p_D)=0;
// Exogenous Shocks ;
// Exogenous shocks;											
shock_LTV=rho_LTV*shock_LTV(-1)+E_LTV;
shock_H=rho_H*shock_H(-1)+ E_H ;
// ;
end;														
steady;
resid;
check;
shocks;
var	E_LTV   = std_LTV^2;
var	E_H     = std_H^2;
end;
%==========================================================================
options_.nograph = 1;
stoch_simul(order=1,irf=20);
figure(1)
subplot(5,2,1)
plot(4*oo_.irfs.R_E_H,'r','LineWidth',2)
legend('Policy rate')
subplot(5,2,2)
plot(oo_.irfs.Y_E_H,'b','LineWidth',2)
legend('GDP')
subplot(5,2,3)
plot(4*oo_.irfs.pii_E_H,'k','LineWidth',2)
legend('inflation')
subplot(5,2,4)
plot(oo_.irfs.T_D_E_H,'b-o','LineWidth',2)
legend('house price')
subplot(5,2,5)
plot(oo_.irfs.C_E_H,'r-x','LineWidth',2)
legend('Cp')
subplot(5,2,6)
plot(oo_.irfs.CNR_E_H,'b-x','LineWidth',2)
legend('Ci')
subplot(5,2,7)
plot(oo_.irfs.Debt_E_H,'k-o','LineWidth',2)
legend('Debt')
subplot(5,2,8)
plot(oo_.irfs.DNR_E_H,'k-o','LineWidth',2)
legend('Housing impatient')
subplot(5,2,9)
plot(oo_.irfs.DS_E_H,'k-o','LineWidth',2)
legend('Housing patient')
subplot(5,2,10)
plot(oo_.irfs.XI_E_H,'k-o','LineWidth',2)
legend('XI')
figure(2)
subplot(5,2,1)
plot(4*oo_.irfs.R_E_LTV,'r','LineWidth',2)
legend('Policy rate')
subplot(5,2,2)
plot(oo_.irfs.Y_E_LTV,'b','LineWidth',2)
legend('GDP')
subplot(5,2,3)
plot(4*oo_.irfs.pii_E_LTV,'k','LineWidth',2)
legend('inflation')
subplot(5,2,4)
plot(oo_.irfs.T_D_E_LTV,'b-o','LineWidth',2)
legend('house price')
subplot(5,2,5)
plot(oo_.irfs.C_E_LTV,'r-x','LineWidth',2)
legend('Cp')
subplot(5,2,6)
plot(oo_.irfs.CNR_E_LTV,'b-x','LineWidth',2)
legend('Ci')
subplot(5,2,7)
plot(oo_.irfs.Debt_E_LTV,'k-o','LineWidth',2)
legend('Debt')
subplot(5,2,8)
plot(oo_.irfs.DNR_E_LTV,'k-o','LineWidth',2)
legend('Housing impatient')
subplot(5,2,9)
plot(oo_.irfs.DS_E_LTV,'k-o','LineWidth',2)
legend('Housing patient')
subplot(5,2,10)
plot(oo_.irfs.TOTC_E_LTV,'k-o','LineWidth',2)
legend('Total consumption')
%==========================================================================
stoch_simul(order=2,irf=0);
betta = 0.99;
betta_NR = 0.9601;
w1 = oo_.dr.order_var; 
windx1 = strmatch('well',M_.endo_names(w1,:),'exact');
a1=0.5*oo_.dr.ghs2(windx1);
oldindx1 = strmatch('well',M_.endo_names,'exact'); 
a11 = oo_.dr.ys(oldindx1);
Ut         =  a11 + a1 ;
ws = oo_.dr.order_var; 
windxs = strmatch('well_s',M_.endo_names(ws,:),'exact');
as=0.5*oo_.dr.ghs2(windxs);
oldindxs = strmatch('well_s',M_.endo_names,'exact'); 
as1 = oo_.dr.ys(oldindxs);
Uts            =  as1 + as ;
wnr = oo_.dr.order_var; 
windxnr = strmatch('well_b',M_.endo_names(wnr,:),'exact');
anr=0.5*oo_.dr.ghs2(windxnr);
oldindxnr = strmatch('well_b',M_.endo_names,'exact'); 
anr1 = oo_.dr.ys(oldindxnr);
Utnr       =  anr1 + anr ;
% Computing welfare gain/loss:
% (cfr. NS_2014_optimalMP.mod)
%	SOCIAL WELFARE UNDER RAMSEY POLICY         = 4.825235;
%	SAVER WELFARE UNDER RAMSEY POLICY          = 591.332855;
%	BORROWER WELFARE UNDER RAMSEY POLICY       = 11.839594;
wel_tot     = Ut;
wel_sav     = Uts;
wel_bor     = Utnr;
WELFRAM     = 4.825235;
WELFRAM_S   = 591.332855;
WELFRAM_B   = 11.839594;
delta_welf_sav  = 1 - exp((1-betta)   *(WELFRAM_S-wel_sav));
delta_welf_bor  = 1 - exp((1-betta_NR)*(WELFRAM_B-wel_bor));
fprintf	('	SOCIAL WELFARE UNDER RAMSEY POLICY          = ')	;	fprintf	('%f',	WELFRAM);	disp(';')
fprintf	('	SOCIAL WELFARE UNDER SIMPLE RULE            = ')	;	fprintf	('%f',	Ut	);	disp(';')
fprintf	('	SAVER WELFARE UNDER RAMSEY POLICY           = ')	;	fprintf	('%f',	WELFRAM_S);	disp(';')
fprintf	('	SAVER WELFARE UNDER SIMPLE RULE             = ')	;	fprintf	('%f',	Uts);	disp(';')
fprintf	('	BORROWER WELFARE UNDER RAMSEY POLICY        = ')	;	fprintf	('%f',	WELFRAM_B);	disp(';')
fprintf	('	BORROWER WELFARE UNDER SIMPLE RULE          = ')	;	fprintf	('%f',	Utnr);	disp(';')
fprintf	('	WELFARE GAIN SAVER                          = ')	;	fprintf	('%f',	delta_welf_sav	);	disp(';')
fprintf	('	WELFARE GAIN BORROWER                       = ')	;	fprintf	('%f',	delta_welf_bor	);	disp(';')
